<?php
/*======================================================================*\
|| #################################################################### ||
|| # Prune IP Addresses ||
|| # ------------------------------ ||
|| # Deletes saved IP addresses that are older than x days. ||
|| # v: 0.6.1 ||
|| # ------------------------------ ||
|| #################################################################### ||
\*======================================================================*/

// ######################## SET PHP ENVIRONMENT ###########################
error_reporting(E_ALL & ~E_NOTICE & ~8192);
if (!is_object($vbulletin->db))
{
	exit;
}

// ########################################################################
// ######################### START MAIN SCRIPT ############################
// ########################################################################

// IPs of posts older than x days will be set to empty string
$maxage_days =  (isset($vbulletin->options['pips_maxpostage']) && $vbulletin->options['pips_maxpostage'] > 0) ? $vbulletin->options['pips_maxpostage'] : 180;
$maxage_seconds = 86400 * (int)$maxage_days;
$dateline_limit = TIMENOW - $maxage_seconds;

// exclude soft deleted posts (visible = 2)
$nodeleted_qrycondition_posts = ($vbulletin->options['pips_nodeletedposts'] == true) ? ' AND visible < 2 ' : '';
$nodeleted_qrycondition_enum = ($vbulletin->options['pips_nodeletedposts'] == true) ? " AND state != 'deleted' " : '';
$enum_tables = array('groupmessage', 'picturecomment', 'visitormessage');

$vbulletin->db->query_write("
	UPDATE " . TABLE_PREFIX . "post SET ipaddress = ''
	WHERE ipaddress != '' AND dateline < " . $dateline_limit . " " . $nodeleted_qrycondition_posts . "
");
$affected = $vbulletin->db->affected_rows();

$affected_more = 0;
foreach ($enum_tables as $table_name)
{
	$vbulletin->db->query_write("
		UPDATE " . TABLE_PREFIX . $table_name ." SET ipaddress = ''
		WHERE ipaddress != '' AND dateline < " . $dateline_limit . " " . $nodeleted_qrycondition_enum . "
	");
	$affected_more += $vbulletin->db->affected_rows();
}

$affected_user = 0;
$vbulletin->db->query_write("
	UPDATE " . TABLE_PREFIX . "user SET ipaddress = ''
	WHERE ipaddress != '' AND joindate < " . $dateline_limit . "
");
$affected_user = $vbulletin->db->affected_rows();

$runtime = time()-TIMENOW;
$desc = serialize(array($affected, $runtime, $affected_more, $affected_user));

log_cron_action($desc, $nextitem, 1);
?>
